#ifndef CSTATEMANAGER_H
#define CSTATEMANAGER_H

// Irrlicht includes
#include <irrlicht/irrlicht.h>

using namespace irr;

using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// OpenTracks inclues
#include "CGameState.h"

// This is the global state manager that is responsible
// for swapping out game states as needed and delegating
// input to the appropriate function.
class CStateManager
{
    public:

        // Constructor
        CStateManager(IrrlichtDevice *);
        ~CStateManager();

        // The 'main' function that
        // runs the application
        void Go();

        // We have two functions here:
        // - one queues the state change
        // - the other actually does it
        void QueueStateChange(GAME_STATE);
        void SwitchState(GAME_STATE);

        // Accessor functions
        IrrlichtDevice * GetDevice() { return m_device; }

    private:

        // Device
        IrrlichtDevice * m_device;

        // Current game state
        GAME_STATE m_state;
        CGameState * m_state_pointer;
        bool m_state_changing;         // a small flag so that we know when the state needs to be changed
};

#endif
