#ifndef CTRACKMANAGER_H
#define CTRACKMANAGER_H

// Irrlicht includes
#include <irrlicht/irrlicht.h>

using namespace irr;

using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Standard includes
#include <string>
#include <vector>

// OpenTracks includes
#include "CTrack.h"

// The class that manages the track
// being displayed.
class CTrackManager
{
    public:

        CTrackManager(IrrlichtDevice *,int,int);
        ~CTrackManager();

        void SetPiece(TRACK_TYPE,int,int);
        CTrack * GetPiece(int,int);

        // This function returns the offset
        // for a train given a track piece
        // and its offset into that piece
        void CalculateTrainPosition(CTrack *,DIRECTION,float,float &,float &,float &);

        // This function determines, given a piece
        // of track and a direction, the next piece
        // of track and direction
        CTrack * GetNextTrack(CTrack *, DIRECTION, DIRECTION &);

    private:

        // The width and height of the grid
        int m_width, m_height;

        // The actual track piece meshes
        IMesh * m_straight;
        IMesh * m_curved;

        // The grid of track pieces
        std::vector<CTrack *> m_grid;
};

#endif
