#ifndef CTRAIN_H
#define CTRAIN_H

// Irrlicht includes
#include <irrlicht/irrlicht.h>

using namespace irr;

using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Standard includes
#include <string>

// OpenTracks includes
#include "CTrackManager.h"

class CTrain
{
    public:

        CTrain(IrrlichtDevice *,u32,CTrack *,std::string);
        ~CTrain();

        void SetSpeed(float speed) { m_speed = speed; }

        // Get information
        float GetPosX() { return m_node->getPosition().X; }
        float GetPosZ() { return m_node->getPosition().Z; }
        float GetRotY() { return m_node->getRotation().Y; }

        // Processes the train
        void Process(CTrackManager *,u32);

    private:

        IMesh * m_mesh;          // the train's mesh
        IMeshSceneNode * m_node; // the scene node

        // Information about where the train is
        float m_speed;    // blocks per second
        DIRECTION m_direction; // direction
        u32 m_start_time; // the time when the train entered the current piece of track
        CTrack * m_current_track;
};

#endif
