#ifndef CTRAINMANAGER_H
#define CTRAINMANAGER_H

// Standard includes
#include <vector>

// OpenTracks includes
#include "CTrain.h"
#include "CTrackManager.h"

class CTrainManager
{
    public:

        CTrainManager(CTrackManager *);
        ~CTrainManager();

        void AddTrain(IrrlichtDevice *,u32,int,int);
        CTrain * GetTrain(int i) {  return m_trains.at(i); }

        // Loops through all of the trains,
        // updating them.
        void Process(u32);

    private:

        // A pointer to the track manager
        CTrackManager * m_manager;

        // The list of trains
        std::vector<CTrain *> m_trains;
};

#endif
