#include "CStateManager.h"
#include "CGameState.h"

CGameState::CGameState(CStateManager * pManager)
    : m_manager(pManager)
{
    // Set this item as the current event
    // receiver
    m_manager->GetDevice()->setEventReceiver(this);
}

IrrlichtDevice * CGameState::GetDevice()
 {
     return m_manager->GetDevice();
 }

void CGameState::SwitchState(GAME_STATE new_state)
{
    // We will queue the state change
    m_manager->QueueStateChange(new_state);
}

void CGameState::ClearScreen()
{
    m_manager->GetDevice()->getVideoDriver()->beginScene(true, true, SColor(0,0,0,0));
}

void CGameState::Done()
{
    m_manager->GetDevice()->getVideoDriver()->endScene();
}
