#include <unistd.h>

#include "CStateManager.h"
#include "CLoadingState.h"

CLoadingState::CLoadingState(CStateManager * pManager)
    : CGameState(pManager), m_loading_texture(NULL)
{
    // Load the loading texture
    m_loading_texture = m_manager->GetDevice()->getVideoDriver()->getTexture(DATA_DIR "/textures/loading.jpg");
}

CLoadingState::~CLoadingState()
{
    // NOTE: we do NOT free the texture
}

void CLoadingState::RenderFrame(u32 cur_time)
{
    // Clear the screen
    ClearScreen();

    // We need to display the loading texture
    m_manager->GetDevice()->getVideoDriver()->draw2DImage(m_loading_texture, position2d<s32>(80,50));

    // End the scene
    Done();

    // Sleep for 2 seconds
    sleep(2);

    // Switch game states to playing
    SwitchState(GS_PLAYING);
}
