#include "CSkybox.h"

CSkybox::CSkybox(IrrlichtDevice * pDevice, int width, int height)
    : m_node(NULL)
{
    // Load the mesh for this piece
    IMesh * mesh = pDevice->getSceneManager()->getMesh(DATA_DIR "/models/skybox.b3d");

    // Now add the mesh to the scene manager
    m_node = pDevice->getSceneManager()->addMeshSceneNode(mesh);

    // Set the position of the object based
    // on the center of the ground
    m_node->setPosition(vector3df(width,0,height));

    // Disable lighting on it for now
    m_node->setMaterialFlag(EMF_LIGHTING, false);
    m_node->setMaterialTexture(0, pDevice->getVideoDriver()->getTexture(DATA_DIR "/textures/sky.jpg"));
}

CSkybox::~CSkybox()
{
    m_node->remove();
}
