#include "CTrainManager.h"

CTrainManager::CTrainManager(CTrackManager * pManager)
    : m_manager(pManager)
{
    //...
}

CTrainManager::~CTrainManager()
{
    //...
}

void CTrainManager::AddTrain(IrrlichtDevice * pDevice, u32 t_time, int x, int y)
{
    // We need to find the piece of track
    // that corresponds to the given coords

    CTrack * pTrack = m_manager->GetPiece(x,y);
    TRACK_TYPE tt = pTrack->GetPiece();

    if(tt != TT_NUM_PIECES)
    {
        // Create the train and give it  a small speed
        CTrain * pTrain = new CTrain(pDevice,t_time,pTrack,DATA_DIR "/models/simple_train.b3d");
        pTrain->SetSpeed(1.5f);

        m_trains.push_back(pTrain);
    }
}

void CTrainManager::Process(u32 t_time)
{
    for(unsigned int i=0; i<m_trains.size(); ++i)
    {
        m_trains.at(i)->Process(m_manager,t_time);
    }
}
